#!/bin/sh
PROTOCOL=$1
DOMAIN=$2

modify_htaccess()
{
		URI=$1
		cat > abweb/.htaccess << EOF
SetEnvIf Referer "^$URI" RefererCheck
Order deny,allow
Deny from all
Allow from env=RefererCheck
<Files ~ "\.(js|json)$">
Header add Pragma "no-cache"
Header set Cache-Control no-cache
</Files>
EOF
}

modify_api()
{
	URI_PREFIX=$1
	cat > abweb/common/json/sys/conf.json << EOF
{
        "apiUrl"              : "$URI_PREFIX/{0}/abvapi",
        "apiLoginUrl"         : "$URI_PREFIX/nuabvapi",
        "apiResourceDlUrl"    : "$URI_PREFIX/{0}/dl",
        "checkApiUrl"         : "$URI_PREFIX/{0}/checkapi/web/",
        "bookShelfCount"      : 15,
        "bookListCount"       : 15,
        "screenlockTimeDefault" : 30,
        "pushPageCount"       : 5,
        "pushTimePeriod"      : 60,
        "debug"               : false,
        "loginPage"           : "login.html",
        "anonymousLoginFlg"   : false,
        "anonymousLoginPath"  : "test",
        "anonymousLoginId"    : "nologin",
        "appName"             : "ABookWebCL",
        "appVersion"          : "0.0.1",
        "optMusicMode"        : 1,
        "previewFlg"          : false
}
EOF
}

modify_htaccess "$PROTOCOL://$DOMAIN/acms/webvw/"
modify_api "$PROTOCOL://$DOMAIN/acms"

